pferor avatar pferor committed e44566a

First commit.

Comments (0)

Files changed (65)

.git/COMMIT_EDITMSG

+First commit
+ref: refs/heads/master
+[core]
+	repositoryformatversion = 0
+	filemode = true
+	bare = false
+	logallrefupdates = true
+[remote "origin"]
+	url = git@github.com:pferor/rsa_lite.git
+	fetch = +refs/heads/*:refs/remotes/origin/*
+[branch "master"]
+	remote = origin
+	merge = refs/heads/master
+Unnamed repository; edit this file 'description' to name the repository.

.git/hooks/applypatch-msg.sample

+#!/bin/sh
+#
+# An example hook script to check the commit log message taken by
+# applypatch from an e-mail message.
+#
+# The hook should exit with non-zero status after issuing an
+# appropriate message if it wants to stop the commit.  The hook is
+# allowed to edit the commit message file.
+#
+# To enable this hook, rename this file to "applypatch-msg".
+
+. git-sh-setup
+test -x "$GIT_DIR/hooks/commit-msg" &&
+	exec "$GIT_DIR/hooks/commit-msg" ${1+"$@"}
+:

.git/hooks/commit-msg.sample

+#!/bin/sh
+#
+# An example hook script to check the commit log message.
+# Called by "git commit" with one argument, the name of the file
+# that has the commit message.  The hook should exit with non-zero
+# status after issuing an appropriate message if it wants to stop the
+# commit.  The hook is allowed to edit the commit message file.
+#
+# To enable this hook, rename this file to "commit-msg".
+
+# Uncomment the below to add a Signed-off-by line to the message.
+# Doing this in a hook is a bad idea in general, but the prepare-commit-msg
+# hook is more suited to it.
+#
+# SOB=$(git var GIT_AUTHOR_IDENT | sed -n 's/^\(.*>\).*$/Signed-off-by: \1/p')
+# grep -qs "^$SOB" "$1" || echo "$SOB" >> "$1"
+
+# This example catches duplicate Signed-off-by lines.
+
+test "" = "$(grep '^Signed-off-by: ' "$1" |
+	 sort | uniq -c | sed -e '/^[ 	]*1[ 	]/d')" || {
+	echo >&2 Duplicate Signed-off-by lines.
+	exit 1
+}

.git/hooks/post-update.sample

+#!/bin/sh
+#
+# An example hook script to prepare a packed repository for use over
+# dumb transports.
+#
+# To enable this hook, rename this file to "post-update".
+
+exec git update-server-info

.git/hooks/pre-applypatch.sample

+#!/bin/sh
+#
+# An example hook script to verify what is about to be committed
+# by applypatch from an e-mail message.
+#
+# The hook should exit with non-zero status after issuing an
+# appropriate message if it wants to stop the commit.
+#
+# To enable this hook, rename this file to "pre-applypatch".
+
+. git-sh-setup
+test -x "$GIT_DIR/hooks/pre-commit" &&
+	exec "$GIT_DIR/hooks/pre-commit" ${1+"$@"}
+:

.git/hooks/pre-commit.sample

+#!/bin/sh
+#
+# An example hook script to verify what is about to be committed.
+# Called by "git commit" with no arguments.  The hook should
+# exit with non-zero status after issuing an appropriate message if
+# it wants to stop the commit.
+#
+# To enable this hook, rename this file to "pre-commit".
+
+if git rev-parse --verify HEAD >/dev/null 2>&1
+then
+	against=HEAD
+else
+	# Initial commit: diff against an empty tree object
+	against=4b825dc642cb6eb9a060e54bf8d69288fbee4904
+fi
+
+# If you want to allow non-ascii filenames set this variable to true.
+allownonascii=$(git config hooks.allownonascii)
+
+# Redirect output to stderr.
+exec 1>&2
+
+# Cross platform projects tend to avoid non-ascii filenames; prevent
+# them from being added to the repository. We exploit the fact that the
+# printable range starts at the space character and ends with tilde.
+if [ "$allownonascii" != "true" ] &&
+	# Note that the use of brackets around a tr range is ok here, (it's
+	# even required, for portability to Solaris 10's /usr/bin/tr), since
+	# the square bracket bytes happen to fall in the designated range.
+	test $(git diff --cached --name-only --diff-filter=A -z $against |
+	  LC_ALL=C tr -d '[ -~]\0' | wc -c) != 0
+then
+	echo "Error: Attempt to add a non-ascii file name."
+	echo
+	echo "This can cause problems if you want to work"
+	echo "with people on other platforms."
+	echo
+	echo "To be portable it is advisable to rename the file ..."
+	echo
+	echo "If you know what you are doing you can disable this"
+	echo "check using:"
+	echo
+	echo "  git config hooks.allownonascii true"
+	echo
+	exit 1
+fi
+
+# If there are whitespace errors, print the offending file names and fail.
+exec git diff-index --check --cached $against --

.git/hooks/pre-rebase.sample

+#!/bin/sh
+#
+# Copyright (c) 2006, 2008 Junio C Hamano
+#
+# The "pre-rebase" hook is run just before "git rebase" starts doing
+# its job, and can prevent the command from running by exiting with
+# non-zero status.
+#
+# The hook is called with the following parameters:
+#
+# $1 -- the upstream the series was forked from.
+# $2 -- the branch being rebased (or empty when rebasing the current branch).
+#
+# This sample shows how to prevent topic branches that are already
+# merged to 'next' branch from getting rebased, because allowing it
+# would result in rebasing already published history.
+
+publish=next
+basebranch="$1"
+if test "$#" = 2
+then
+	topic="refs/heads/$2"
+else
+	topic=`git symbolic-ref HEAD` ||
+	exit 0 ;# we do not interrupt rebasing detached HEAD
+fi
+
+case "$topic" in
+refs/heads/??/*)
+	;;
+*)
+	exit 0 ;# we do not interrupt others.
+	;;
+esac
+
+# Now we are dealing with a topic branch being rebased
+# on top of master.  Is it OK to rebase it?
+
+# Does the topic really exist?
+git show-ref -q "$topic" || {
+	echo >&2 "No such branch $topic"
+	exit 1
+}
+
+# Is topic fully merged to master?
+not_in_master=`git rev-list --pretty=oneline ^master "$topic"`
+if test -z "$not_in_master"
+then
+	echo >&2 "$topic is fully merged to master; better remove it."
+	exit 1 ;# we could allow it, but there is no point.
+fi
+
+# Is topic ever merged to next?  If so you should not be rebasing it.
+only_next_1=`git rev-list ^master "^$topic" ${publish} | sort`
+only_next_2=`git rev-list ^master           ${publish} | sort`
+if test "$only_next_1" = "$only_next_2"
+then
+	not_in_topic=`git rev-list "^$topic" master`
+	if test -z "$not_in_topic"
+	then
+		echo >&2 "$topic is already up-to-date with master"
+		exit 1 ;# we could allow it, but there is no point.
+	else
+		exit 0
+	fi
+else
+	not_in_next=`git rev-list --pretty=oneline ^${publish} "$topic"`
+	/usr/bin/perl -e '
+		my $topic = $ARGV[0];
+		my $msg = "* $topic has commits already merged to public branch:\n";
+		my (%not_in_next) = map {
+			/^([0-9a-f]+) /;
+			($1 => 1);
+		} split(/\n/, $ARGV[1]);
+		for my $elem (map {
+				/^([0-9a-f]+) (.*)$/;
+				[$1 => $2];
+			} split(/\n/, $ARGV[2])) {
+			if (!exists $not_in_next{$elem->[0]}) {
+				if ($msg) {
+					print STDERR $msg;
+					undef $msg;
+				}
+				print STDERR " $elem->[1]\n";
+			}
+		}
+	' "$topic" "$not_in_next" "$not_in_master"
+	exit 1
+fi
+
+exit 0
+
+################################################################
+
+This sample hook safeguards topic branches that have been
+published from being rewound.
+
+The workflow assumed here is:
+
+ * Once a topic branch forks from "master", "master" is never
+   merged into it again (either directly or indirectly).
+
+ * Once a topic branch is fully cooked and merged into "master",
+   it is deleted.  If you need to build on top of it to correct
+   earlier mistakes, a new topic branch is created by forking at
+   the tip of the "master".  This is not strictly necessary, but
+   it makes it easier to keep your history simple.
+
+ * Whenever you need to test or publish your changes to topic
+   branches, merge them into "next" branch.
+
+The script, being an example, hardcodes the publish branch name
+to be "next", but it is trivial to make it configurable via
+$GIT_DIR/config mechanism.
+
+With this workflow, you would want to know:
+
+(1) ... if a topic branch has ever been merged to "next".  Young
+    topic branches can have stupid mistakes you would rather
+    clean up before publishing, and things that have not been
+    merged into other branches can be easily rebased without
+    affecting other people.  But once it is published, you would
+    not want to rewind it.
+
+(2) ... if a topic branch has been fully merged to "master".
+    Then you can delete it.  More importantly, you should not
+    build on top of it -- other people may already want to
+    change things related to the topic as patches against your
+    "master", so if you need further changes, it is better to
+    fork the topic (perhaps with the same name) afresh from the
+    tip of "master".
+
+Let's look at this example:
+
+		   o---o---o---o---o---o---o---o---o---o "next"
+		  /       /           /           /
+		 /   a---a---b A     /           /
+		/   /               /           /
+	       /   /   c---c---c---c B         /
+	      /   /   /             \         /
+	     /   /   /   b---b C     \       /
+	    /   /   /   /             \     /
+    ---o---o---o---o---o---o---o---o---o---o---o "master"
+
+
+A, B and C are topic branches.
+
+ * A has one fix since it was merged up to "next".
+
+ * B has finished.  It has been fully merged up to "master" and "next",
+   and is ready to be deleted.
+
+ * C has not merged to "next" at all.
+
+We would want to allow C to be rebased, refuse A, and encourage
+B to be deleted.
+
+To compute (1):
+
+	git rev-list ^master ^topic next
+	git rev-list ^master        next
+
+	if these match, topic has not merged in next at all.
+
+To compute (2):
+
+	git rev-list master..topic
+
+	if this is empty, it is fully merged to "master".

.git/hooks/prepare-commit-msg.sample

+#!/bin/sh
+#
+# An example hook script to prepare the commit log message.
+# Called by "git commit" with the name of the file that has the
+# commit message, followed by the description of the commit
+# message's source.  The hook's purpose is to edit the commit
+# message file.  If the hook fails with a non-zero status,
+# the commit is aborted.
+#
+# To enable this hook, rename this file to "prepare-commit-msg".
+
+# This hook includes three examples.  The first comments out the
+# "Conflicts:" part of a merge commit.
+#
+# The second includes the output of "git diff --name-status -r"
+# into the message, just before the "git status" output.  It is
+# commented because it doesn't cope with --amend or with squashed
+# commits.
+#
+# The third example adds a Signed-off-by line to the message, that can
+# still be edited.  This is rarely a good idea.
+
+case "$2,$3" in
+  merge,)
+    /usr/bin/perl -i.bak -ne 's/^/# /, s/^# #/#/ if /^Conflicts/ .. /#/; print' "$1" ;;
+
+# ,|template,)
+#   /usr/bin/perl -i.bak -pe '
+#      print "\n" . `git diff --cached --name-status -r`
+#	 if /^#/ && $first++ == 0' "$1" ;;
+
+  *) ;;
+esac
+
+# SOB=$(git var GIT_AUTHOR_IDENT | sed -n 's/^\(.*>\).*$/Signed-off-by: \1/p')
+# grep -qs "^$SOB" "$1" || echo "$SOB" >> "$1"

.git/hooks/update.sample

+#!/bin/sh
+#
+# An example hook script to blocks unannotated tags from entering.
+# Called by "git receive-pack" with arguments: refname sha1-old sha1-new
+#
+# To enable this hook, rename this file to "update".
+#
+# Config
+# ------
+# hooks.allowunannotated
+#   This boolean sets whether unannotated tags will be allowed into the
+#   repository.  By default they won't be.
+# hooks.allowdeletetag
+#   This boolean sets whether deleting tags will be allowed in the
+#   repository.  By default they won't be.
+# hooks.allowmodifytag
+#   This boolean sets whether a tag may be modified after creation. By default
+#   it won't be.
+# hooks.allowdeletebranch
+#   This boolean sets whether deleting branches will be allowed in the
+#   repository.  By default they won't be.
+# hooks.denycreatebranch
+#   This boolean sets whether remotely creating branches will be denied
+#   in the repository.  By default this is allowed.
+#
+
+# --- Command line
+refname="$1"
+oldrev="$2"
+newrev="$3"
+
+# --- Safety check
+if [ -z "$GIT_DIR" ]; then
+	echo "Don't run this script from the command line." >&2
+	echo " (if you want, you could supply GIT_DIR then run" >&2
+	echo "  $0 <ref> <oldrev> <newrev>)" >&2
+	exit 1
+fi
+
+if [ -z "$refname" -o -z "$oldrev" -o -z "$newrev" ]; then
+	echo "Usage: $0 <ref> <oldrev> <newrev>" >&2
+	exit 1
+fi
+
+# --- Config
+allowunannotated=$(git config --bool hooks.allowunannotated)
+allowdeletebranch=$(git config --bool hooks.allowdeletebranch)
+denycreatebranch=$(git config --bool hooks.denycreatebranch)
+allowdeletetag=$(git config --bool hooks.allowdeletetag)
+allowmodifytag=$(git config --bool hooks.allowmodifytag)
+
+# check for no description
+projectdesc=$(sed -e '1q' "$GIT_DIR/description")
+case "$projectdesc" in
+"Unnamed repository"* | "")
+	echo "*** Project description file hasn't been set" >&2
+	exit 1
+	;;
+esac
+
+# --- Check types
+# if $newrev is 0000...0000, it's a commit to delete a ref.
+zero="0000000000000000000000000000000000000000"
+if [ "$newrev" = "$zero" ]; then
+	newrev_type=delete
+else
+	newrev_type=$(git cat-file -t $newrev)
+fi
+
+case "$refname","$newrev_type" in
+	refs/tags/*,commit)
+		# un-annotated tag
+		short_refname=${refname##refs/tags/}
+		if [ "$allowunannotated" != "true" ]; then
+			echo "*** The un-annotated tag, $short_refname, is not allowed in this repository" >&2
+			echo "*** Use 'git tag [ -a | -s ]' for tags you want to propagate." >&2
+			exit 1
+		fi
+		;;
+	refs/tags/*,delete)
+		# delete tag
+		if [ "$allowdeletetag" != "true" ]; then
+			echo "*** Deleting a tag is not allowed in this repository" >&2
+			exit 1
+		fi
+		;;
+	refs/tags/*,tag)
+		# annotated tag
+		if [ "$allowmodifytag" != "true" ] && git rev-parse $refname > /dev/null 2>&1
+		then
+			echo "*** Tag '$refname' already exists." >&2
+			echo "*** Modifying a tag is not allowed in this repository." >&2
+			exit 1
+		fi
+		;;
+	refs/heads/*,commit)
+		# branch
+		if [ "$oldrev" = "$zero" -a "$denycreatebranch" = "true" ]; then
+			echo "*** Creating a branch is not allowed in this repository" >&2
+			exit 1
+		fi
+		;;
+	refs/heads/*,delete)
+		# delete branch
+		if [ "$allowdeletebranch" != "true" ]; then
+			echo "*** Deleting a branch is not allowed in this repository" >&2
+			exit 1
+		fi
+		;;
+	refs/remotes/*,commit)
+		# tracking branch
+		;;
+	refs/remotes/*,delete)
+		# delete tracking branch
+		if [ "$allowdeletebranch" != "true" ]; then
+			echo "*** Deleting a tracking branch is not allowed in this repository" >&2
+			exit 1
+		fi
+		;;
+	*)
+		# Anything else (is there anything else?)
+		echo "*** Update hook: unknown type of update to ref $refname of type $newrev_type" >&2
+		exit 1
+		;;
+esac
+
+# --- Finished
+exit 0

Binary file added.

.git/info/exclude

+# git ls-files --others --exclude-from=.git/info/exclude
+# Lines that start with '#' are comments.
+# For a project mostly in C, the following would be a good set of
+# exclude patterns (uncomment them if you want to use them):
+# *.[oa]
+# *~
+0000000000000000000000000000000000000000 310dad8ccb2823917bc26f87bf09638f140e5b7c Pferor <pferor@gmail.com> 1324785667 +0100	commit (initial): First commit

.git/logs/refs/heads/master

+0000000000000000000000000000000000000000 310dad8ccb2823917bc26f87bf09638f140e5b7c Pferor <pferor@gmail.com> 1324785667 +0100	commit (initial): First commit

.git/logs/refs/remotes/origin/master

+0000000000000000000000000000000000000000 310dad8ccb2823917bc26f87bf09638f140e5b7c Pferor <pferor@gmail.com> 1324785796 +0100	update by push
Add a comment to this file

.git/objects/06/2e6e3deb3084133d2b0021fa3930724a32b52e

Binary file added.

.git/objects/09/7160d4ffd3b4b9823246c2830eb142e01d6ac4

+x}��j�0�{ާ�!���ǖ�0����e�k�~��BɻG[��

.git/objects/1e/9015e3969d1d9a5795423e69b70250cdac0dfb

+x}P�J�@�<_Q��و�MeAs��L�i�L��I oOXYu��uU?���C����I��
+9�
Add a comment to this file

.git/objects/22/af8805df529144eea778ff860851bda6a6b4a6

Binary file added.

Add a comment to this file

.git/objects/27/3c05f388ac8ada658b124dff808b54ab4bee73

Binary file added.

Add a comment to this file

.git/objects/29/5c2d4a4158007857a5e82596b88f4480f68aac

Binary file added.

Add a comment to this file

.git/objects/31/0dad8ccb2823917bc26f87bf09638f140e5b7c

Binary file added.

Add a comment to this file

.git/objects/3a/5517ff22b241ac523c81a23eed841e544b71a0

Binary file added.

.git/objects/3d/6f77769764a3f6486b956f4afca811f21a6b01

+xmRMK�@���b$
+�aS�Ah���~Q
+2�iKX���=
Add a comment to this file

.git/objects/54/8706f4c01a9364e51a3ad5c636616064aaec45

Binary file added.

Add a comment to this file

.git/objects/58/97c4d4872d56f06c007e5951070fe559856f8e

Binary file added.

Add a comment to this file

.git/objects/61/6c130b5a32b3c8384a3fd98998e8819a569341

Binary file added.

Add a comment to this file

.git/objects/67/4c516e8ce985ca3d06bbb8e6de55d118146af4

Binary file added.

.git/objects/75/7f87c88b586e75e0ff45dee1ce9054dfded266

+xu��J1�]�)��0
+r�q��ʃ���
+��'B�W��h��
Add a comment to this file

.git/objects/76/8f9254fbd8b414c91d6709f9858b525ae82e4e

Binary file added.

Add a comment to this file

.git/objects/7c/7ee884628abd87079c6e2bc59048e2f2922461

Binary file added.

Add a comment to this file

.git/objects/7e/c51f5bbcac7fa880803866a941fd2296837210

Binary file added.

Add a comment to this file

.git/objects/94/a9ed024d3859793618152ea559a168bbcbb5e2

Binary file added.

.git/objects/99/6af2e9fd2cfd32fbd588b5c6bd1431798c6c24

+xuRˊ�0��_�a.�a���aɐ�$,�r

.git/objects/a6/42cc1ab61e9249e0e511b57fbedb810a3acb46

+x�SMo�@��_�
+�p[����YG�5�R���*|QZ:���a3���mI�)�I(�{Ғd��eX7J����X��6��j
+���

.git/objects/b2/ef7716e6e4db846fac0d5426f71e9b932d7f18

+xu��N�0D��S p
+�p��d�6vd;���	�]����>7��ܝ<i?d���C��d�]��
Add a comment to this file

.git/objects/c0/0c8243d57c88267330f919c2f8e417bba3235e

Binary file added.

Add a comment to this file

.git/objects/c1/1796e6663d8ddd01102d637945fbf5a793c416

Binary file added.

Add a comment to this file

.git/objects/c6/9e7e28e74204b23bc906910f3bfdcf900b4b2b

Binary file added.

.git/objects/f6/0551afd4ccacf637b6a74eb873de6cbe4f19d9

+x}SM��0�_1�H����������nTi��R;;�*���{�Ǫ@�%�x���<g[�-�t�x6K�	��"ڨ�tr�9c�6�
+|d��UZA�Q��$|}x���'fϢh����<�M^����/�V�+m�m����1��7�Qv?�����+�Dn��=]�����@���%�
+���`�
+ηE�2�k2ǒ

.git/refs/heads/master

+310dad8ccb2823917bc26f87bf09638f140e5b7c

.git/refs/remotes/origin/master

+310dad8ccb2823917bc26f87bf09638f140e5b7c
+Pferor <pferor [AT] gmail [DOT] com>
+
+                    GNU GENERAL PUBLIC LICENSE
+                       Version 3, 29 June 2007
+
+ Copyright (C) 2007 Free Software Foundation, Inc. <http://fsf.org/>
+ Everyone is permitted to copy and distribute verbatim copies
+ of this license document, but changing it is not allowed.
+
+                            Preamble
+
+  The GNU General Public License is a free, copyleft license for
+software and other kinds of works.
+
+  The licenses for most software and other practical works are designed
+to take away your freedom to share and change the works.  By contrast,
+the GNU General Public License is intended to guarantee your freedom to
+share and change all versions of a program--to make sure it remains free
+software for all its users.  We, the Free Software Foundation, use the
+GNU General Public License for most of our software; it applies also to
+any other work released this way by its authors.  You can apply it to
+your programs, too.
+
+  When we speak of free software, we are referring to freedom, not
+price.  Our General Public Licenses are designed to make sure that you
+have the freedom to distribute copies of free software (and charge for
+them if you wish), that you receive source code or can get it if you
+want it, that you can change the software or use pieces of it in new
+free programs, and that you know you can do these things.
+
+  To protect your rights, we need to prevent others from denying you
+these rights or asking you to surrender the rights.  Therefore, you have
+certain responsibilities if you distribute copies of the software, or if
+you modify it: responsibilities to respect the freedom of others.
+
+  For example, if you distribute copies of such a program, whether
+gratis or for a fee, you must pass on to the recipients the same
+freedoms that you received.  You must make sure that they, too, receive
+or can get the source code.  And you must show them these terms so they
+know their rights.
+
+  Developers that use the GNU GPL protect your rights with two steps:
+(1) assert copyright on the software, and (2) offer you this License
+giving you legal permission to copy, distribute and/or modify it.
+
+  For the developers' and authors' protection, the GPL clearly explains
+that there is no warranty for this free software.  For both users' and
+authors' sake, the GPL requires that modified versions be marked as
+changed, so that their problems will not be attributed erroneously to
+authors of previous versions.
+
+  Some devices are designed to deny users access to install or run
+modified versions of the software inside them, although the manufacturer
+can do so.  This is fundamentally incompatible with the aim of
+protecting users' freedom to change the software.  The systematic
+pattern of such abuse occurs in the area of products for individuals to
+use, which is precisely where it is most unacceptable.  Therefore, we
+have designed this version of the GPL to prohibit the practice for those
+products.  If such problems arise substantially in other domains, we
+stand ready to extend this provision to those domains in future versions
+of the GPL, as needed to protect the freedom of users.
+
+  Finally, every program is threatened constantly by software patents.
+States should not allow patents to restrict development and use of
+software on general-purpose computers, but in those that do, we wish to
+avoid the special danger that patents applied to a free program could
+make it effectively proprietary.  To prevent this, the GPL assures that
+patents cannot be used to render the program non-free.
+
+  The precise terms and conditions for copying, distribution and
+modification follow.
+
+                       TERMS AND CONDITIONS
+
+  0. Definitions.
+
+  "This License" refers to version 3 of the GNU General Public License.
+
+  "Copyright" also means copyright-like laws that apply to other kinds of
+works, such as semiconductor masks.
+
+  "The Program" refers to any copyrightable work licensed under this
+License.  Each licensee is addressed as "you".  "Licensees" and
+"recipients" may be individuals or organizations.
+
+  To "modify" a work means to copy from or adapt all or part of the work
+in a fashion requiring copyright permission, other than the making of an
+exact copy.  The resulting work is called a "modified version" of the
+earlier work or a work "based on" the earlier work.
+
+  A "covered work" means either the unmodified Program or a work based
+on the Program.
+
+  To "propagate" a work means to do anything with it that, without
+permission, would make you directly or secondarily liable for
+infringement under applicable copyright law, except executing it on a
+computer or modifying a private copy.  Propagation includes copying,
+distribution (with or without modification), making available to the
+public, and in some countries other activities as well.
+
+  To "convey" a work means any kind of propagation that enables other
+parties to make or receive copies.  Mere interaction with a user through
+a computer network, with no transfer of a copy, is not conveying.
+
+  An interactive user interface displays "Appropriate Legal Notices"
+to the extent that it includes a convenient and prominently visible
+feature that (1) displays an appropriate copyright notice, and (2)
+tells the user that there is no warranty for the work (except to the
+extent that warranties are provided), that licensees may convey the
+work under this License, and how to view a copy of this License.  If
+the interface presents a list of user commands or options, such as a
+menu, a prominent item in the list meets this criterion.
+
+  1. Source Code.
+
+  The "source code" for a work means the preferred form of the work
+for making modifications to it.  "Object code" means any non-source
+form of a work.
+
+  A "Standard Interface" means an interface that either is an official
+standard defined by a recognized standards body, or, in the case of
+interfaces specified for a particular programming language, one that
+is widely used among developers working in that language.
+
+  The "System Libraries" of an executable work include anything, other
+than the work as a whole, that (a) is included in the normal form of
+packaging a Major Component, but which is not part of that Major
+Component, and (b) serves only to enable use of the work with that
+Major Component, or to implement a Standard Interface for which an
+implementation is available to the public in source code form.  A
+"Major Component", in this context, means a major essential component
+(kernel, window system, and so on) of the specific operating system
+(if any) on which the executable work runs, or a compiler used to
+produce the work, or an object code interpreter used to run it.
+
+  The "Corresponding Source" for a work in object code form means all
+the source code needed to generate, install, and (for an executable
+work) run the object code and to modify the work, including scripts to
+control those activities.  However, it does not include the work's
+System Libraries, or general-purpose tools or generally available free
+programs which are used unmodified in performing those activities but
+which are not part of the work.  For example, Corresponding Source
+includes interface definition files associated with source files for
+the work, and the source code for shared libraries and dynamically
+linked subprograms that the work is specifically designed to require,
+such as by intimate data communication or control flow between those
+subprograms and other parts of the work.
+
+  The Corresponding Source need not include anything that users
+can regenerate automatically from other parts of the Corresponding
+Source.
+
+  The Corresponding Source for a work in source code form is that
+same work.
+
+  2. Basic Permissions.
+
+  All rights granted under this License are granted for the term of
+copyright on the Program, and are irrevocable provided the stated
+conditions are met.  This License explicitly affirms your unlimited
+permission to run the unmodified Program.  The output from running a
+covered work is covered by this License only if the output, given its
+content, constitutes a covered work.  This License acknowledges your
+rights of fair use or other equivalent, as provided by copyright law.
+
+  You may make, run and propagate covered works that you do not
+convey, without conditions so long as your license otherwise remains
+in force.  You may convey covered works to others for the sole purpose
+of having them make modifications exclusively for you, or provide you
+with facilities for running those works, provided that you comply with
+the terms of this License in conveying all material for which you do
+not control copyright.  Those thus making or running the covered works
+for you must do so exclusively on your behalf, under your direction
+and control, on terms that prohibit them from making any copies of
+your copyrighted material outside their relationship with you.
+
+  Conveying under any other circumstances is permitted solely under
+the conditions stated below.  Sublicensing is not allowed; section 10
+makes it unnecessary.
+
+  3. Protecting Users' Legal Rights From Anti-Circumvention Law.
+
+  No covered work shall be deemed part of an effective technological
+measure under any applicable law fulfilling obligations under article
+11 of the WIPO copyright treaty adopted on 20 December 1996, or
+similar laws prohibiting or restricting circumvention of such
+measures.
+
+  When you convey a covered work, you waive any legal power to forbid
+circumvention of technological measures to the extent such circumvention
+is effected by exercising rights under this License with respect to
+the covered work, and you disclaim any intention to limit operation or
+modification of the work as a means of enforcing, against the work's
+users, your or third parties' legal rights to forbid circumvention of
+technological measures.
+
+  4. Conveying Verbatim Copies.
+
+  You may convey verbatim copies of the Program's source code as you
+receive it, in any medium, provided that you conspicuously and
+appropriately publish on each copy an appropriate copyright notice;
+keep intact all notices stating that this License and any
+non-permissive terms added in accord with section 7 apply to the code;
+keep intact all notices of the absence of any warranty; and give all
+recipients a copy of this License along with the Program.
+
+  You may charge any price or no price for each copy that you convey,
+and you may offer support or warranty protection for a fee.
+
+  5. Conveying Modified Source Versions.
+
+  You may convey a work based on the Program, or the modifications to
+produce it from the Program, in the form of source code under the
+terms of section 4, provided that you also meet all of these conditions:
+
+    a) The work must carry prominent notices stating that you modified
+    it, and giving a relevant date.
+
+    b) The work must carry prominent notices stating that it is
+    released under this License and any conditions added under section
+    7.  This requirement modifies the requirement in section 4 to
+    "keep intact all notices".
+
+    c) You must license the entire work, as a whole, under this
+    License to anyone who comes into possession of a copy.  This
+    License will therefore apply, along with any applicable section 7
+    additional terms, to the whole of the work, and all its parts,
+    regardless of how they are packaged.  This License gives no
+    permission to license the work in any other way, but it does not
+    invalidate such permission if you have separately received it.
+
+    d) If the work has interactive user interfaces, each must display
+    Appropriate Legal Notices; however, if the Program has interactive
+    interfaces that do not display Appropriate Legal Notices, your
+    work need not make them do so.
+
+  A compilation of a covered work with other separate and independent
+works, which are not by their nature extensions of the covered work,
+and which are not combined with it such as to form a larger program,
+in or on a volume of a storage or distribution medium, is called an
+"aggregate" if the compilation and its resulting copyright are not
+used to limit the access or legal rights of the compilation's users
+beyond what the individual works permit.  Inclusion of a covered work
+in an aggregate does not cause this License to apply to the other
+parts of the aggregate.
+
+  6. Conveying Non-Source Forms.
+
+  You may convey a covered work in object code form under the terms
+of sections 4 and 5, provided that you also convey the
+machine-readable Corresponding Source under the terms of this License,
+in one of these ways:
+
+    a) Convey the object code in, or embodied in, a physical product
+    (including a physical distribution medium), accompanied by the
+    Corresponding Source fixed on a durable physical medium
+    customarily used for software interchange.
+
+    b) Convey the object code in, or embodied in, a physical product
+    (including a physical distribution medium), accompanied by a
+    written offer, valid for at least three years and valid for as
+    long as you offer spare parts or customer support for that product
+    model, to give anyone who possesses the object code either (1) a
+    copy of the Corresponding Source for all the software in the
+    product that is covered by this License, on a durable physical
+    medium customarily used for software interchange, for a price no
+    more than your reasonable cost of physically performing this
+    conveying of source, or (2) access to copy the
+    Corresponding Source from a network server at no charge.
+
+    c) Convey individual copies of the object code with a copy of the
+    written offer to provide the Corresponding Source.  This
+    alternative is allowed only occasionally and noncommercially, and
+    only if you received the object code with such an offer, in accord
+    with subsection 6b.
+
+    d) Convey the object code by offering access from a designated
+    place (gratis or for a charge), and offer equivalent access to the
+    Corresponding Source in the same way through the same place at no
+    further charge.  You need not require recipients to copy the
+    Corresponding Source along with the object code.  If the place to
+    copy the object code is a network server, the Corresponding Source
+    may be on a different server (operated by you or a third party)
+    that supports equivalent copying facilities, provided you maintain
+    clear directions next to the object code saying where to find the
+    Corresponding Source.  Regardless of what server hosts the
+    Corresponding Source, you remain obligated to ensure that it is
+    available for as long as needed to satisfy these requirements.
+
+    e) Convey the object code using peer-to-peer transmission, provided
+    you inform other peers where the object code and Corresponding
+    Source of the work are being offered to the general public at no
+    charge under subsection 6d.
+
+  A separable portion of the object code, whose source code is excluded
+from the Corresponding Source as a System Library, need not be
+included in conveying the object code work.
+
+  A "User Product" is either (1) a "consumer product", which means any
+tangible personal property which is normally used for personal, family,
+or household purposes, or (2) anything designed or sold for incorporation
+into a dwelling.  In determining whether a product is a consumer product,
+doubtful cases shall be resolved in favor of coverage.  For a particular
+product received by a particular user, "normally used" refers to a
+typical or common use of that class of product, regardless of the status
+of the particular user or of the way in which the particular user
+actually uses, or expects or is expected to use, the product.  A product
+is a consumer product regardless of whether the product has substantial
+commercial, industrial or non-consumer uses, unless such uses represent
+the only significant mode of use of the product.
+
+  "Installation Information" for a User Product means any methods,
+procedures, authorization keys, or other information required to install
+and execute modified versions of a covered work in that User Product from
+a modified version of its Corresponding Source.  The information must
+suffice to ensure that the continued functioning of the modified object
+code is in no case prevented or interfered with solely because
+modification has been made.
+
+  If you convey an object code work under this section in, or with, or
+specifically for use in, a User Product, and the conveying occurs as
+part of a transaction in which the right of possession and use of the
+User Product is transferred to the recipient in perpetuity or for a
+fixed term (regardless of how the transaction is characterized), the
+Corresponding Source conveyed under this section must be accompanied
+by the Installation Information.  But this requirement does not apply
+if neither you nor any third party retains the ability to install
+modified object code on the User Product (for example, the work has
+been installed in ROM).
+
+  The requirement to provide Installation Information does not include a
+requirement to continue to provide support service, warranty, or updates
+for a work that has been modified or installed by the recipient, or for
+the User Product in which it has been modified or installed.  Access to a
+network may be denied when the modification itself materially and
+adversely affects the operation of the network or violates the rules and
+protocols for communication across the network.
+
+  Corresponding Source conveyed, and Installation Information provided,
+in accord with this section must be in a format that is publicly
+documented (and with an implementation available to the public in
+source code form), and must require no special password or key for
+unpacking, reading or copying.
+
+  7. Additional Terms.
+
+  "Additional permissions" are terms that supplement the terms of this
+License by making exceptions from one or more of its conditions.
+Additional permissions that are applicable to the entire Program shall
+be treated as though they were included in this License, to the extent
+that they are valid under applicable law.  If additional permissions
+apply only to part of the Program, that part may be used separately
+under those permissions, but the entire Program remains governed by
+this License without regard to the additional permissions.
+
+  When you convey a copy of a covered work, you may at your option
+remove any additional permissions from that copy, or from any part of
+it.  (Additional permissions may be written to require their own
+removal in certain cases when you modify the work.)  You may place
+additional permissions on material, added by you to a covered work,
+for which you have or can give appropriate copyright permission.
+
+  Notwithstanding any other provision of this License, for material you
+add to a covered work, you may (if authorized by the copyright holders of
+that material) supplement the terms of this License with terms:
+
+    a) Disclaiming warranty or limiting liability differently from the
+    terms of sections 15 and 16 of this License; or
+
+    b) Requiring preservation of specified reasonable legal notices or
+    author attributions in that material or in the Appropriate Legal
+    Notices displayed by works containing it; or
+
+    c) Prohibiting misrepresentation of the origin of that material, or
+    requiring that modified versions of such material be marked in
+    reasonable ways as different from the original version; or
+
+    d) Limiting the use for publicity purposes of names of licensors or
+    authors of the material; or
+
+    e) Declining to grant rights under trademark law for use of some
+    trade names, trademarks, or service marks; or
+
+    f) Requiring indemnification of licensors and authors of that
+    material by anyone who conveys the material (or modified versions of
+    it) with contractual assumptions of liability to the recipient, for
+    any liability that these contractual assumptions directly impose on
+    those licensors and authors.
+
+  All other non-permissive additional terms are considered "further
+restrictions" within the meaning of section 10.  If the Program as you
+received it, or any part of it, contains a notice stating that it is
+governed by this License along with a term that is a further
+restriction, you may remove that term.  If a license document contains
+a further restriction but permits relicensing or conveying under this
+License, you may add to a covered work material governed by the terms
+of that license document, provided that the further restriction does
+not survive such relicensing or conveying.
+
+  If you add terms to a covered work in accord with this section, you
+must place, in the relevant source files, a statement of the
+additional terms that apply to those files, or a notice indicating
+where to find the applicable terms.
+
+  Additional terms, permissive or non-permissive, may be stated in the
+form of a separately written license, or stated as exceptions;
+the above requirements apply either way.
+
+  8. Termination.
+
+  You may not propagate or modify a covered work except as expressly
+provided under this License.  Any attempt otherwise to propagate or
+modify it is void, and will automatically terminate your rights under
+this License (including any patent licenses granted under the third
+paragraph of section 11).
+
+  However, if you cease all violation of this License, then your
+license from a particular copyright holder is reinstated (a)
+provisionally, unless and until the copyright holder explicitly and
+finally terminates your license, and (b) permanently, if the copyright
+holder fails to notify you of the violation by some reasonable means
+prior to 60 days after the cessation.
+
+  Moreover, your license from a particular copyright holder is
+reinstated permanently if the copyright holder notifies you of the
+violation by some reasonable means, this is the first time you have
+received notice of violation of this License (for any work) from that
+copyright holder, and you cure the violation prior to 30 days after
+your receipt of the notice.
+
+  Termination of your rights under this section does not terminate the
+licenses of parties who have received copies or rights from you under
+this License.  If your rights have been terminated and not permanently
+reinstated, you do not qualify to receive new licenses for the same
+material under section 10.
+
+  9. Acceptance Not Required for Having Copies.
+
+  You are not required to accept this License in order to receive or
+run a copy of the Program.  Ancillary propagation of a covered work
+occurring solely as a consequence of using peer-to-peer transmission
+to receive a copy likewise does not require acceptance.  However,
+nothing other than this License grants you permission to propagate or
+modify any covered work.  These actions infringe copyright if you do
+not accept this License.  Therefore, by modifying or propagating a
+covered work, you indicate your acceptance of this License to do so.
+
+  10. Automatic Licensing of Downstream Recipients.
+
+  Each time you convey a covered work, the recipient automatically
+receives a license from the original licensors, to run, modify and
+propagate that work, subject to this License.  You are not responsible
+for enforcing compliance by third parties with this License.
+
+  An "entity transaction" is a transaction transferring control of an
+organization, or substantially all assets of one, or subdividing an
+organization, or merging organizations.  If propagation of a covered
+work results from an entity transaction, each party to that
+transaction who receives a copy of the work also receives whatever
+licenses to the work the party's predecessor in interest had or could
+give under the previous paragraph, plus a right to possession of the
+Corresponding Source of the work from the predecessor in interest, if
+the predecessor has it or can get it with reasonable efforts.
+
+  You may not impose any further restrictions on the exercise of the
+rights granted or affirmed under this License.  For example, you may
+not impose a license fee, royalty, or other charge for exercise of
+rights granted under this License, and you may not initiate litigation
+(including a cross-claim or counterclaim in a lawsuit) alleging that
+any patent claim is infringed by making, using, selling, offering for
+sale, or importing the Program or any portion of it.
+
+  11. Patents.
+
+  A "contributor" is a copyright holder who authorizes use under this
+License of the Program or a work on which the Program is based.  The
+work thus licensed is called the contributor's "contributor version".
+
+  A contributor's "essential patent claims" are all patent claims
+owned or controlled by the contributor, whether already acquired or
+hereafter acquired, that would be infringed by some manner, permitted
+by this License, of making, using, or selling its contributor version,
+but do not include claims that would be infringed only as a
+consequence of further modification of the contributor version.  For
+purposes of this definition, "control" includes the right to grant
+patent sublicenses in a manner consistent with the requirements of
+this License.
+
+  Each contributor grants you a non-exclusive, worldwide, royalty-free
+patent license under the contributor's essential patent claims, to
+make, use, sell, offer for sale, import and otherwise run, modify and
+propagate the contents of its contributor version.
+
+  In the following three paragraphs, a "patent license" is any express
+agreement or commitment, however denominated, not to enforce a patent
+(such as an express permission to practice a patent or covenant not to
+sue for patent infringement).  To "grant" such a patent license to a
+party means to make such an agreement or commitment not to enforce a
+patent against the party.
+
+  If you convey a covered work, knowingly relying on a patent license,
+and the Corresponding Source of the work is not available for anyone
+to copy, free of charge and under the terms of this License, through a
+publicly available network server or other readily accessible means,
+then you must either (1) cause the Corresponding Source to be so
+available, or (2) arrange to deprive yourself of the benefit of the
+patent license for this particular work, or (3) arrange, in a manner
+consistent with the requirements of this License, to extend the patent
+license to downstream recipients.  "Knowingly relying" means you have
+actual knowledge that, but for the patent license, your conveying the
+covered work in a country, or your recipient's use of the covered work
+in a country, would infringe one or more identifiable patents in that
+country that you have reason to believe are valid.
+
+  If, pursuant to or in connection with a single transaction or
+arrangement, you convey, or propagate by procuring conveyance of, a
+covered work, and grant a patent license to some of the parties
+receiving the covered work authorizing them to use, propagate, modify
+or convey a specific copy of the covered work, then the patent license
+you grant is automatically extended to all recipients of the covered
+work and works based on it.
+
+  A patent license is "discriminatory" if it does not include within
+the scope of its coverage, prohibits the exercise of, or is
+conditioned on the non-exercise of one or more of the rights that are
+specifically granted under this License.  You may not convey a covered
+work if you are a party to an arrangement with a third party that is
+in the business of distributing software, under which you make payment
+to the third party based on the extent of your activity of conveying
+the work, and under which the third party grants, to any of the
+parties who would receive the covered work from you, a discriminatory
+patent license (a) in connection with copies of the covered work
+conveyed by you (or copies made from those copies), or (b) primarily
+for and in connection with specific products or compilations that
+contain the covered work, unless you entered into that arrangement,
+or that patent license was granted, prior to 28 March 2007.
+
+  Nothing in this License shall be construed as excluding or limiting
+any implied license or other defenses to infringement that may
+otherwise be available to you under applicable patent law.
+
+  12. No Surrender of Others' Freedom.
+
+  If conditions are imposed on you (whether by court order, agreement or
+otherwise) that contradict the conditions of this License, they do not
+excuse you from the conditions of this License.  If you cannot convey a
+covered work so as to satisfy simultaneously your obligations under this
+License and any other pertinent obligations, then as a consequence you may
+not convey it at all.  For example, if you agree to terms that obligate you
+to collect a royalty for further conveying from those to whom you convey
+the Program, the only way you could satisfy both those terms and this
+License would be to refrain entirely from conveying the Program.
+
+  13. Use with the GNU Affero General Public License.
+
+  Notwithstanding any other provision of this License, you have
+permission to link or combine any covered work with a work licensed
+under version 3 of the GNU Affero General Public License into a single
+combined work, and to convey the resulting work.  The terms of this
+License will continue to apply to the part which is the covered work,
+but the special requirements of the GNU Affero General Public License,
+section 13, concerning interaction through a network will apply to the
+combination as such.
+
+  14. Revised Versions of this License.
+
+  The Free Software Foundation may publish revised and/or new versions of
+the GNU General Public License from time to time.  Such new versions will
+be similar in spirit to the present version, but may differ in detail to
+address new problems or concerns.
+
+  Each version is given a distinguishing version number.  If the
+Program specifies that a certain numbered version of the GNU General
+Public License "or any later version" applies to it, you have the
+option of following the terms and conditions either of that numbered
+version or of any later version published by the Free Software
+Foundation.  If the Program does not specify a version number of the
+GNU General Public License, you may choose any version ever published
+by the Free Software Foundation.
+
+  If the Program specifies that a proxy can decide which future
+versions of the GNU General Public License can be used, that proxy's
+public statement of acceptance of a version permanently authorizes you
+to choose that version for the Program.
+
+  Later license versions may give you additional or different
+permissions.  However, no additional obligations are imposed on any
+author or copyright holder as a result of your choosing to follow a
+later version.
+
+  15. Disclaimer of Warranty.
+
+  THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY
+APPLICABLE LAW.  EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT
+HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY
+OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO,
+THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM
+IS WITH YOU.  SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF
+ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
+
+  16. Limitation of Liability.
+
+  IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
+WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR CONVEYS
+THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES, INCLUDING ANY
+GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE
+USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF
+DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD
+PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS),
+EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF
+SUCH DAMAGES.
+
+  17. Interpretation of Sections 15 and 16.
+
+  If the disclaimer of warranty and limitation of liability provided
+above cannot be given local legal effect according to their terms,
+reviewing courts shall apply local law that most closely approximates
+an absolute waiver of all civil liability in connection with the
+Program, unless a warranty or assumption of liability accompanies a
+copy of the Program in return for a fee.
+
+                     END OF TERMS AND CONDITIONS
+
+            How to Apply These Terms to Your New Programs
+
+  If you develop a new program, and you want it to be of the greatest
+possible use to the public, the best way to achieve this is to make it
+free software which everyone can redistribute and change under these terms.
+
+  To do so, attach the following notices to the program.  It is safest
+to attach them to the start of each source file to most effectively
+state the exclusion of warranty; and each file should have at least
+the "copyright" line and a pointer to where the full notice is found.
+
+    <one line to give the program's name and a brief idea of what it does.>
+    Copyright (C) <year>  <name of author>
+
+    This program is free software: you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation, either version 3 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+Also add information on how to contact you by electronic and paper mail.
+
+  If the program does terminal interaction, make it output a short
+notice like this when it starts in an interactive mode:
+
+    <program>  Copyright (C) <year>  <name of author>
+    This program comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
+    This is free software, and you are welcome to redistribute it
+    under certain conditions; type `show c' for details.
+
+The hypothetical commands `show w' and `show c' should show the appropriate
+parts of the General Public License.  Of course, your program's commands
+might be different; for a GUI interface, you would use an "about box".
+
+  You should also get your employer (if you work as a programmer) or school,
+if any, to sign a "copyright disclaimer" for the program, if necessary.
+For more information on this, and how to apply and follow the GNU GPL, see
+<http://www.gnu.org/licenses/>.
+
+  The GNU General Public License does not permit incorporating your program
+into proprietary programs.  If your program is a subroutine library, you
+may consider it more useful to permit linking proprietary applications with
+the library.  If this is what you want to do, use the GNU Lesser General
+Public License instead of this License.  But first, please read
+<http://www.gnu.org/philosophy/why-not-lgpl.html>.
+#
+# Makefile
+#
+
+## Directories
+PWD   = $(CURDIR)
+I_DIR = ${PWD}/include
+S_DIR = ${PWD}/src
+L_DIR = ${PWD}/lib
+O_DIR = ${PWD}/obj
+B_DIR = ${PWD}/bin
+
+
+## Compiler & linker opts.
+CC      = gcc
+CCFLAGS = --pedantic -Wall -Werror -I ${I_DIR}
+LDFLAGS = -s -lm -L ${L_DIR}
+
+
+## Makefile opts.
+SHELL = /bin/sh
+.SUFFIXES:
+.SUFFIXES: .h .c .o
+
+
+## Files options
+TARGET = ${B_DIR}/main
+OBJS = $(patsubst ${S_DIR}/%.c, ${O_DIR}/%.o, $(wildcard ${S_DIR}/*.c))
+
+
+## Linkage
+${TARGET}: ${OBJS}
+	${CC} ${LDFLAGS} -o $@ $^
+
+
+## Compilation
+${O_DIR}/%.o: ${S_DIR}/%.c
+	${CC} ${CCFLAGS} -c -o $@ $<
+
+
+## Make options
+.PHONY: clean
+
+all:
+	make ${TARGET}
+
+clean:
+	rm --force ${OBJS} ${TARGET}
+
+clean-obj:
+	rm --force ${OBJS}
+
+clean-all:
+	make clean
+
+help:
+	@echo "Type:"
+	@echo "  'make all':      Build"
+	@echo "  'make clean':    Cleans bianry and object files"
+	@echo "  'make clean-obj: Cleans only object files"
+	@echo ""
+	@echo " Binary will be placed in '${TARGET}'"
+
+Light RSA implementation in C with the only goal of understanding
+the algorithm a little better.
+
+No big deal.
+
+Compiling & linking:
+
+  Building help (it's just this very help)
+    $ make help
+
+  Build the application:
+    $ make all
+
+  Clean object files:
+    $ make clean-obj
+
+  Clean object and binary files:
+    $ make clean
+
+  There is no installer and there never will be.
+
+
+Build errors:
+
+  In order to build you must make the directories `bin/'
+  and `obj/' at the same level as `include/' and `src/',
+  or else the compilation won't work.
+

include/exponentiation.h

+/**
+ * @file exponentiation.h
+ *
+ * @brief Exponentiation definition using the square and multiply
+ *        algorithm for fast exponentation
+ *
+ * @details Uses the square and multiply algorithm for fast
+ *          exponentation
+ *
+ *  This works but is quite inefficient:
+ *
+ *  1. This could take advantage of fermat's little theorem to speed
+ *     the exponentiation, expecially for the case of RSA decryption.
+ *
+ *  2. The squares in the algorithm will begin to repeat. Rather than
+ *     simply calculating them over and over, some form of
+ *     array/vector/list should be used to lookup the repeating
+ *     values.
+ */
+
+#ifndef EXPONENTIATION_H
+#define EXPONENTIATION_H
+
+/* System includes */
+#include <stdint.h>
+
+
+/**
+ * @brief Evaluate p^q (mod m) quickly
+ *
+ * @details Algorithm:
+ *
+ *  1. Write q in binary form:
+ *     q = (an)2^n + (a(n-1))2^(n-1) + ... + * (a2)2^2 + (a1)2^1
+ *
+ *  2. Compute p^1, p^2, p^4, ..., p^(2^n) (mod m) by squaring the
+ *     previous term in the sequence
+ *
+ *  3. Multiply together all a^(2^i) such that (ai) = 1 to get the
+ *     result
+ *
+ * @param p Base
+ * @param q Exponent
+ * @param m Modulus of the congrunence
+ *
+ * @pre m < 65535
+ *
+ * @return The result of evaluate p^q (mod m), or 0 otherwise
+ */
+uint32_t exponentiate(uint32_t p,
+                      uint32_t q,
+                      uint32_t m);
+
+
+#endif /* ! EXPONENTIATION_H */
+

include/findkeys.h

+/**
+ * @file findkeys.h
+ *
+ * @brief Finds valid keys for the RSA scheme
+ */
+
+#ifndef FINDKEYS_H
+#define FINDKEYS_H
+
+/* System includes */
+#include <stdint.h>
+
+
+/**
+ * @brief Finds keys for the RSA cryptosystem
+ *
+ * @param *e Public key
+ * @param *d Private key
+ * @param *n Key length
+ */
+void find_keys(uint32_t *e,
+               uint32_t *d,
+               uint32_t *n);
+
+
+#endif /* FINDKEYS_H */
+

include/findprime.h

+/**
+ * @file findprime.h
+ *
+ * @brief Prime number finder declaration
+ *
+ * @details Find prime using wheel factorization to generate a prime
+ *          in a certain range.
+ */
+
+#ifndef FINDPRIME_H
+#define FINDPRIME_H
+
+/* System includes */
+#include <stdint.h>
+
+
+/**
+ * @brief Randomly finds a prime number between lower and upper using
+ *        wheel factorization to test for primality
+ *
+ * @details This could be much faster with advanced primality tests
+ *          and expecially with probabilistic primality testing, which
+ *          any serious RSA implementation should use. The lower bound
+ *          is included, the upper bound is excluded.
+ *
+ * @param lower Lower boundary
+ * @param upper Upper boundary
+ *
+ * @return Prime number
+ *
+ * @note
+ *  (http://www.utm.edu/research/primes/glossary/WheelFactorization.html
+ */
+uint32_t find_prime(uint32_t lower,
+                    uint32_t upper);
+
+
+#endif /* ! FINDPRIME_H */
+
+/**
+ * @file gcd.h
+ *
+ * @brief Euclidean algorithm for greatest common divisor (GCD)
+ *        declaration
+ */
+
+#ifndef GCD_H
+#define GCD_H
+
+/* System includes */
+#include <stdint.h>
+
+
+/**
+ * @brief Finds the GCD of a and b using the Euclidean algorithm
+ *
+ * @param a Factor
+ * @oaram b Factor
+ *
+ * @return GCD of @e a and @e b
+ */
+uint32_t gcd(uint32_t a, uint32_t b);
+
+
+#endif /* ! GDC_H */
+

include/inverse.h

+/**
+ * @file inverse.h
+ *
+ * @brief Finds the modular inverse of a number using the extended
+ *        Euclidean algorithm
+ *
+ * @details An implementation of the extended euclidean algorithm
+ *          Finds solutions to diophantine equations of the form:
+ *          ax + by = gcd(a, b)
+ */
+
+#ifndef INVERSE_H
+#define INVERSE_H
+
+/* System includes */
+#include <stdint.h>
+
+
+/**
+ * @brief Extended Euclidean algorithm for finding the modular inverse
+ *        of a number
+ *
+ * @details Algorithm:
+ *
+ *   do {
+ *     quotient <- Divide oldx * number +
+ *                        oldy * mod by x * number +
+ *                        y * mod
+ *     newx <- Subtract x * quotient from oldx
+ *     newy <- Subtract y * quotient from oldy
+ *     oldx <- x
+ *     oldy <- y
+ *     x <- newx
+ *     y <- newy
+ *   } while ( x * number + y * mod != 1)
+ *
+ * @param number The number that we want inverse of
+ * @param mod    The base to find the inverse
+ *
+ * @return The inverse, or zero if isn't one
+ */
+uint32_t inverse(uint32_t number,
+                 uint32_t mod);
+
+
+#endif /* ! INVERSE_H */
+

include/randseed.h

+/**
+ * @file randseed.h
+ *
+ * @brief Seed of the random number generator declaration
+ */
+
+#ifndef RANDSEED_H
+#define RANDSEED_H
+
+
+/**
+ * @brief Seeds the random number generator from '/dev/random'
+ *
+ * @return 0 if everything is ok, 1 if '/dev/random' couldn't be open
+ *         or 2 if there is some reading error in '/dev/random/'
+ *
+ * @todo Find a better implementation
+ */
+void seed_random(void);
+
+
+#endif /* ! RANDSEED_H */
+
+/**
+ * @file rsa.h
+ *
+ * @brief RSA encryption/decryption routines declaration
+ */
+
+#ifndef RSA_H
+#define RSA_H
+
+/* Project includes */
+#include <rsakey.h>
+
+/* System includes */
+#include <stdint.h>
+
+
+/**
+ * @typedef Encrypted data type
+ *
+ * @brief RSA encrypted data type declaration
+ */
+typedef uint32_t rsa_enc_t;
+
+
+/* Public interface */
+/**
+ * @brief Encrypts a message with RSA using the public key
+ *
+ * @param *cypher_msg Where the encrypted message will be stored
+ * @param **plain     Plain text message
+ * @param plain_len   Length of the plain message
+ * @param e           Public key
+ * @param n           Key length
+ */
+void rsa_encrypt_public(rsa_enc_t **cypher_msg,
+                        const char *plain,
+                        unsigned int plain_len,
+                        uint32_t e,
+                        uint32_t n);
+
+/**
+ * @brief Decrypts  a message with RSA using the private key
+ *
+ * @param **plain     Where the encrypted string will be stored
+ * @param *cypher_msg Encrypted message
+ * @param plain_len   Length of the plain message
+ * @param d           Private key
+ * @param n           Key length
+ */
+void rsa_decrypt_private(char **plain,
+                         const rsa_enc_t *cypher_msg,
+                         unsigned int plain_len,
+                         uint32_t d,
+                         uint32_t n);
+
+/**
+ * @brief RSA encryption
+ *
+ * @param **cypher_msg Where the encrypted string will be stored
+ * @param *plain       Plain message
+ * @param e            Public key
+ * @param n            Key lenght (modulus)
+ *
+ * @return Public and private keys struture
+ */
+rsakey_t rsa_encrypt(rsa_enc_t **cypher_msg,
+                     const char *plain);
+
+/**
+ * @brief RSA decryption
+ *
+ * @param **plain     Where the decrypted string will be stored
+ * @param *cypher_msg Encrypted  message
+ * @param rsakey      Key used to decrypt
+ */
+void rsa_decrypt(char **plain,
+                 const rsa_enc_t *cypher_msg,
+                 const rsakey_t rsakey);
+
+
+#endif /* ! RSA_H */
+
+/**
+ * @file rsakey.h
+ *
+ * @brief RSA key structure declaration
+ */
+
+#ifndef RSAKEY_H
+#define RSAKEY_H
+
+/* System includes */
+#include <stdint.h>
+
+
+/**
+ * @typedef key_t
+ *
+ * @brief RSA key
+ */
+typedef struct rsakey_s {
+  uint32_t d;      /**< Public key */
+  uint32_t e;      /**< Private key */
+  uint32_t n;      /**< Key length */
+  uint16_t msglen; /**< Message length */
+} rsakey_t;
+
+
+/**
+ * @brief Initialize a RSA key
+ *
+ * @param *rsakey Key to initialize
+ * @param *msglen Lenght of the plain message to encrypt
+ */
+void rsakey_init(rsakey_t *rsakey, uint16_t msglen);
+
+
+#endif /* ! RSAKEY_H */
+

src/exponentiation.c

+/**
+ * @file exponentiation.c
+ *
+ * @brief Exponentiation implementation
+ */
+
+/* System includes */
+#include <stdint.h>
+
+/* Local includes */
+#include <exponentiation.h>
+
+
+uint32_t
+exponentiate(uint32_t p,
+             uint32_t q,
+             uint32_t m)
+{
+  uint32_t square = 0, result = 0;
+
+  /* m must be less that 65536 or else we may get an overflow
+   * situation */
+  if (m > 65536) {
+    return 0;
+  }
+
+  /* Do the first step */
+  square = p % m;
+  if (q & 0x1) {
+    result = square;
+  }
+  q = q >> 1;
+
+  /* Continue until there are no more 1's left in q */
+  while (q != 0) {
+    /* Square the previous term and evaluate the mod */
+    square = (square * square) % m;
+
+    /* Update the result */
+    if (q & 0x1) {
+      if (result == 0) {
+        result = square;
+      } else {
+        result = (result * square) % m;
+      }
+    }
+
+    /* Bitshift the exponent */
+    q = q >> 1;
+  }
+
+  return result;
+}
+
+/**
+ * @file findkeys.c
+ *
+ * @brief Finds valid keys for the RSA scheme
+ */
+
+/* System includes */
+#include <stdint.h>
+#include <stdlib.h>  /* random */
+
+/* Project includes */
+#include <findprime.h>
+#include <gcd.h>
+#include <inverse.h>
+#include <randseed.h>
+
+/* Local includes */
+#include <findkeys.h>
+
+
+/* Finds keys for the RSA cryptosystem */
+void
+find_keys(uint32_t *e,
+          uint32_t *d,
+          uint32_t *n)
+{
+  uint32_t p = 0, q = 0, phi = 0;
+
+  /* Seed the random number generator and get p, q */
+  seed_random();
+
+  /* Get p, q; length = 8, 8 bits so p*q = n is at least 15 bits so
+   * n < 2^16 (overflow) */
+  p = find_prime(128, 255);
+  /* Weird stuff happens when p == q */
+  do {
+    q = find_prime(128, 255);
+  } while (q == p);
+
+  /* n = p * q; phi = (p - 1) * (q - 1) */
+  *n = p * q;
+  phi = (p - 1) * (q - 1);
+
+  /* Choose e such that gcd(e, phi) == 1 and choose e < n so we don't
+   * overflow */
+  do {
+    *e = 0;
+    do {
+      *e = rand() % *n;
+    }
+    while (*e % 2 == 0);
+  }
+  while (gcd(*e, phi) != 1);
+
+  /* find d, the inverse of e (mod phi) */
+  *d = inverse(*e, phi);
+
+  return;
+}
+
+/**
+ * @file findprime.c
+ *
+ * @brief Prime number finder implementation
+ */
+
+/* System includes */
+#include <stdint.h>
+#include <math.h>   /* sqrt and ceil */
+#include <stdlib.h> /* rand */
+
+/* Local includes */
+#include <findprime.h>
+#include <randseed.h>
+
+
+/* Randomly finds a prime number between lower and upper using wheel
+ * factorization to test for primality. */
+uint32_t
+find_prime(uint32_t lower,
+           uint32_t upper)
+{
+  /* A bunch of arrays that we will use to test primality */
+  uint32_t test[] = { 2, 3, 5, 7 };
+  uint32_t divisors[] = {
+      1,  11,  13,  17,  19,  23,  29,  31,  37,  41,
+     43,  47,  53,  59,  61,  67,  71,  73,  79,  83,
+     89,  97, 101, 103, 107, 109, 113, 121, 127, 131,
+    137, 139, 143, 149, 151, 157, 163, 167, 169, 173,
+    179, 181, 187, 191, 193, 197, 199, 209
+  };
+  uint32_t num_divisors = 48, num_test = 4;
+  uint32_t new_prime = 0, test_product = 2 * 3 * 5 * 7;
+  uint32_t root = 0, multiple = 0, counter = 0;
+  uint32_t current_prime =  0;
+
+  seed_random();
+
+  /* Now we generate a random number in the specified range and do
+   * wheel factorization to verify primality until we find a prime */
+  /* Subtract because we are going to add 2 */
+  do {
+    new_prime = rand() % (upper - lower) + lower - 2;
+  } while (new_prime % 2 == 0);
+
+  while (!current_prime) {
+    /* Test the next odd number */
+    new_prime += 2;
+
+    /* Handle the passed the top problem and the overflow the integer
+     * problem */
+    if (new_prime > upper) {
+      new_prime -= lower;
+    }
+    if (new_prime < lower) {
+      new_prime += lower;
+    }
+    current_prime = new_prime;
+
+    /* Test it with the test divisors first, skipping 2 */
+    for (counter = 1; counter < num_test && current_prime; ++counter) {
+      if (current_prime % test[counter] == 0) {
+        current_prime = 0;
+      }
+    }
+
+    if (current_prime) {
+      root = ceil(sqrt(current_prime));
+
+      /* We stop testing divisors when we have passed the square
+       * root */
+      /* Skip 1 when we start testing */
+      for (counter = 1, multiple = 0;
+           current_prime && divisors[counter] + multiple <= root;
+           ++counter) {
+        if (current_prime % (divisors[counter] + multiple) == 0) {
+          current_prime = 0;
+        }
+
+        /* Increase the multiple when we need to */
+        if (counter == num_divisors) {
+          counter = 0;
+          multiple += test_product;
+        }
+      }
+    } /* if (current_prime...) */
+  } /* while (!current_prime...) */
+
+  return current_prime;
+}
+
+/**
+ * @file gcd.c
+ *
+ * @brief Euclidean algorithm for GCD implementation
+ */
+
+/* System includes */
+#include <stdint.h>
+
+/* Local includes */
+#include <gcd.h>
+
+
+/* Computes the GCD of a and b */
+uint32_t
+gcd(uint32_t a,
+    uint32_t b)
+{
+  uint32_t r = a, old_r = 0;
+
+  if (b > a) {
+    a = b;
+    b = r;
+    
+  }
+
+  while (r != 0) {
+    old_r = r;
+    r = a % b;
+    a = b;
+    b = r;
+  }
+
+  return old_r;
+}
+
+/**
+ * @file inverse.c
+ *
+ * @brief Finds the modular inverse of a number using the extended
+ *        Euclidean algorithm
+ */
+
+/* Project includes */
+#include <stdint.h>
+#include <gcd.h>
+
+/* Local includes */
+#include <inverse.h>
+
+
+/* Extended Euclidean algorithm for finding the modular inverse of a
+ * number */
+uint32_t
+inverse(uint32_t number,
+        uint32_t mod)
+{
+  long int quotient = 0;
+  long int x = 0, y = 1;
+  long int oldx = 1, oldy = 0;
+  long int newx = 0, newy = 0;
+
+  if (gcd(number, mod) != 1) {
+    return 0;
+  }
+
+  /* Algorithm */
+  while ((x * number) + (y * mod) != 1) {
+    quotient =
+      ((oldx * number) + (oldy * mod)) /
+      ((x * number) + (y * mod));
+
+    newx = oldx - (x * quotient);
+    newy = oldy - (y * quotient);
+
+    oldx = x;
+    oldy = y;
+
+    x = newx;
+    y = newy;
+  }
+
+  if (x < 0) {
+    x += mod;
+  }
+
+  return x;
+}
+/**
+ * @file main.c
+ *
+ * @brief RSA test (only ASCII characters)
+ *
+ * @fixme Memory issues; some 'Segmentation fault', etc.
+ */
+
+/* System includes */
+#include <stdlib.h>
+#include <stdio.h>
+#include <string.h>
+
+/* Project includes */
+#include <rsa.h>
+
+
+/* Show usage */
+void show_usage(FILE *fp, const char *arg0);
+
+
+/* Main entry */
+int main(int argc, char *argv[])
+{
+  char *input;
+  char *output;
+  rsa_enc_t *enc_str;
+  rsakey_t rsakey;
+
+  /* Check arguments */
+  if (argc < 2) {
+    show_usage(stdout, argv[0]);
+    return 1;
+  }
+
+  /* Allocate memory */
+  input    = (char *) malloc(sizeof(char) * (strlen(argv[1]) + 1));
+  output   = (char *) malloc(sizeof(char) * (strlen(argv[1]) + 1));
+  enc_str  = (rsa_enc_t *) malloc(sizeof(rsa_enc_t) *
+                                 (strlen(argv[1]) + 1));
+  if (input == NULL || output == NULL || enc_str == NULL) {
+    fprintf(stderr, "%s: No enough memory\n", argv[0]);
+    return 1;
+  }
+
+  /* Get the argument */
+  strncpy(input, argv[1], (strlen(argv[1]) + 1));
+
+  /* We encrypt... */
+  rsakey = rsa_encrypt(&enc_str, input);
+
+  /* ... and then we decrypt */
+  rsa_decrypt(&output, enc_str, rsakey);
+
+  /* *******************************************************/
+  /* at this point, 'output' should be the same as 'input' */
+  /* *******************************************************/
+
+  /* Find public and private keys */
+  fprintf(stderr, "Public key = %u, private key = %u, length = %u\n",
+          rsakey.e, rsakey.d, rsakey.n);
+
+
+  /* Check */
+  fprintf(stdout, "After RSA encryption/decryption:\n %s\n", output);
+  if (strcmp(input, output) == 0) {
+    fprintf(stdout, "\n%s: Decrypted data MATCH input. OK!\n", argv[0]);
+  } else {
+    fprintf(stderr, "\n%s: Decrypted data does NOT match input\n", argv[0]);
+  }
+
+  /* Free heap memory */
+  free(input);
+  /*free(output);*/ /* <-- I CANNOT FREE MEMORY WITHOUT A MAP DUMP! */
+  /*free(enc_str);*/
+
+  return 0;
+}
+
+
+/* Show usage on screen */
+void
+show_usage(FILE *fp, const char *arg0)
+{
+  fprintf(fp, "Usage: %s <string>\n\n", arg0);
+}
+
+/**
+ * @file randseed.c
+ *
+ * @brief Seed of the random number generator implementation
+ */
+
+/* System includes */
+#include <stdlib.h> /* random */
+#include <time.h>   /* time */
+
+/* Local includes */